function $AdfDhtmlZOrderLayer$$($containerElementId$$) {
  this.Init($containerElementId$$);
}
$goog$exportSymbol$$("AdfDhtmlZOrderLayer", $AdfDhtmlZOrderLayer$$);
$AdfObject$$.$createSubclass$($AdfDhtmlZOrderLayer$$);
$AdfDhtmlZOrderLayer$$.$_MINIMAL_Z_INDEX$ = 20;
$AdfDhtmlZOrderLayer$$.prototype.Init = function $$AdfDhtmlZOrderLayer$$$$Init$($containerElementId$$1$$) {
  $AdfDhtmlZOrderLayer$$.$superclass$.Init.call(this);
  this.$_containerElementId$ = $containerElementId$$1$$;
  this.$_elements$ = [];
  this.$_elementsCount$ = 0;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlZOrderLayer.prototype.Init", {Init:$AdfDhtmlZOrderLayer$$.prototype.Init});
$AdfDhtmlZOrderLayer$$.prototype.$getContainerElement$ = function $$AdfDhtmlZOrderLayer$$$$$getContainerElement$$() {
  var $containerElementId$$2$$ = this.getId();
  return $AdfAgent$$.$AGENT$.getElementById($containerElementId$$2$$);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlZOrderLayer.prototype.getContainerElement", {$getContainerElement$:$AdfDhtmlZOrderLayer$$.prototype.$getContainerElement$});
$AdfDhtmlZOrderLayer$$.prototype.$getContainerElementCount$ = function $$AdfDhtmlZOrderLayer$$$$$getContainerElementCount$$() {
  return this.$_elementsCount$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlZOrderLayer.prototype.getContainerElementCount", {$getContainerElementCount$:$AdfDhtmlZOrderLayer$$.prototype.$getContainerElementCount$});
$AdfDhtmlZOrderLayer$$.prototype.getId = function $$AdfDhtmlZOrderLayer$$$$getId$() {
  return this.$_containerElementId$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlZOrderLayer.prototype.getId", {getId:$AdfDhtmlZOrderLayer$$.prototype.getId});
$AdfDhtmlZOrderLayer$$.prototype.addElement = function $$AdfDhtmlZOrderLayer$$$$addElement$($element$$175$$, $priorElement$$) {
  this.$_elementsCount$++;
  var $elements$$12$$ = this.$_elements$, $i$$216_s$$5$$ = 0;
  $priorElement$$ ? ($i$$216_s$$5$$ = $AdfCollections$$.indexOf($elements$$12$$, $priorElement$$), -1 < $i$$216_s$$5$$ ? $elements$$12$$.splice($i$$216_s$$5$$, 0, $element$$175$$) : ($elements$$12$$.push($element$$175$$), $i$$216_s$$5$$ = $elements$$12$$.length - 1)) : ($elements$$12$$.push($element$$175$$), $i$$216_s$$5$$ = $elements$$12$$.length - 1);
  for (;$i$$216_s$$5$$ < $elements$$12$$.length;$i$$216_s$$5$$++) {
    $i$$216_s$$5$$ in $elements$$12$$ && (this.$_elements$[$i$$216_s$$5$$].style.zIndex = 2 * $i$$216_s$$5$$ + $AdfDhtmlZOrderLayer$$.$_MINIMAL_Z_INDEX$);
  }
  this.$getContainerElement$().appendChild($element$$175$$);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlZOrderLayer.prototype.addElement", {addElement:$AdfDhtmlZOrderLayer$$.prototype.addElement});
$AdfDhtmlZOrderLayer$$.prototype.$removeElement$ = function $$AdfDhtmlZOrderLayer$$$$$removeElement$$($element$$176$$) {
  var $elementsCount$$ = this.$_elementsCount$--, $elements$$13$$ = this.$_elements$, $i$$217$$ = $AdfCollections$$.indexOf($elements$$13$$, $element$$176$$);
  -1 < $i$$217$$ && delete $elements$$13$$[$i$$217$$];
  this.$getContainerElement$().removeChild($element$$176$$);
  0 == $elementsCount$$ && (this.$_elements$ = []);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlZOrderLayer.prototype.removeElement", {$removeElement$:$AdfDhtmlZOrderLayer$$.prototype.$removeElement$});
$AdfDhtmlZOrderLayer$$.prototype.$raiseToFront$ = function $$AdfDhtmlZOrderLayer$$$$$raiseToFront$$($elementIndex$$inline_988_raisingElement$$) {
  var $elements$$14$$ = this.$_elements$, $i$$218$$ = $AdfCollections$$.indexOf($elements$$14$$, $elementIndex$$inline_988_raisingElement$$);
  -1 < $i$$218$$ && (delete $elements$$14$$[$i$$218$$], $elements$$14$$.push($elementIndex$$inline_988_raisingElement$$), $elementIndex$$inline_988_raisingElement$$ = $elements$$14$$.length - 1, this.$_elements$[$elementIndex$$inline_988_raisingElement$$].style.zIndex = 2 * $elementIndex$$inline_988_raisingElement$$ + $AdfDhtmlZOrderLayer$$.$_MINIMAL_Z_INDEX$);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlZOrderLayer.prototype.raiseToFront", {$raiseToFront$:$AdfDhtmlZOrderLayer$$.prototype.$raiseToFront$});
$AdfDhtmlZOrderLayer$$.prototype.$visitElements$ = function $$AdfDhtmlZOrderLayer$$$$$visitElements$$($callback$$91$$) {
  $AdfAssert$$.$assertFunction$($callback$$91$$, "no visitor callback");
  for (var $elements$$15$$ = this.$_elements$, $i$$219$$ = 0;$i$$219$$ < $elements$$15$$.length && !($i$$219$$ in $elements$$15$$ && $callback$$91$$(this, $elements$$15$$[$i$$219$$]));$i$$219$$++) {
  }
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlZOrderLayer.prototype.visitElements", {$visitElements$:$AdfDhtmlZOrderLayer$$.prototype.$visitElements$});
